# Description

The default behaviour of this metronome is simple, a bpm, a metric.

With this basic fonctionality come several other modes. Each mode can be configured through a dedicated menu.

# Main screen

## Normal mode

This is the default mode.

![Main screen in normal mode](1.1_normal.png)

1. BPM: Floating-point values are allowed. There isn't any limit appart those of your phone and settings. ~0.2 to 120000 are possible on my phone
2. Bar: Floating-point bars are allowed. Every 1st beat is a "tic", everything else is a "toc". Ex:
	* 4: 4 beats bar
	* 1: 1 beat bar (only "tics")
	* 0: no bars (only "tocs")
	* 3.5: 7/8 groove
	* 2.66...: 3-3-2
	* 0.3333....: will play triolet
3. Tap In: A tap-in...
4. Mode: Select wich mode to use: "Normal" or the structure to play
5. Menu: Open the settings or the structure editor

## Random Mute mode

Under this mode, the metronome can choose to lower the volume randomly, for a randomized duration. See below for the settings of this mode.

## Structure or Polyrhythms mode

![Main screen mode](1.2_mode.png)

In structure or polyrhythm mode:

1. the BPM now translates into a percentage to control every tempi at once. ex: BPM 200 means the structure/polyrhythm is played twice the speed
2. the bar now sets the times the structure is to be repeated. **0 stands for ad lib**

# Settings menu

Choose wich sounds to use for "tic" and "toc" from real sounds (sticks sound good IMO), generated sounds ou a "muted" sound.

![Settings menu](2.1_settings.png)

1. Spinner to choose the sound
2. If you chose a generated sound, those values represent the pitch in Hz and the length in milliseconds (0 means muted)
3. Sample Rate (Hz) (Do not Touch!) If the BPM limits doesn't suit you and if you know what you are doing, then adjust this. Only use with generated sounds
4. Option wich keeps screen on

Here you can see "tic" set as a stick and "toc" is a generated E4 lasting 50ms.

# Random Mute

![Random Mute](3.1_randommute.png)

In order to adapt the mute, one can act upon the frequencies she will appear and also the duration of the silenced clic.

Ex: We can set a rare mute (every 10 sec) and very "on time" (+/- set to 0). With an expected short duration (2sec) but very variable (+/- set to 4sec).

# Polyrhythms

![Polyrhythms](4.1_polyrhythms.png)

In order to create a polyrhythm, we can simultaneously launch several clics. The max number of allowed clics depends on the number of cores present in your phone's CPU. On a tablet from 2013, I manaed to launch 5 simultaneous clics. 2 or 3 should be enough...

The menu looks like a simplified version of the structure one (specific sounds settings is not yet set). So we can Add/Del clics, save/load polyrhythm... Each clic behave like a mini-metronome, a bpm, a metric and possibly specifics sounds (see below).

## Specifics sounds for a base (loudspeaker icon)

![Rhythm's settings](2.2_minisettings.png)

Specifics sounds settings for the concerned rhythm.

# Structure menu

The idea is to define simple bar or simple elements as **bases** that you combine to build **patterns**, you obtain grouped bars or claves. Combining those patterns allow you to form **structures**.

Using the app ability to handle floating-point bars, adjusting bpms or choosing differents sounds, the structures allow lot of possibilities. The in-app demos are detailed below to illustrate thos possibilities.

![Structure menu](5.1_structures.png)

* Validate/Discard the modifications and return to main screen. Those modifications will be lost if the app is left without saving first
* Write/Load the modifications to/from the phone
* Open a demo structure

![Structure menu](5.2_structures.png)

* Create a base. Opens a small menu offering specifics sounds choices for this base
* Create a pattern. Add a base to the concerned pattern
* Create a structure. Add a pattern to the concerned structure

Use the trashbin to delete something. The loudspeakers are for settings the sounds for the concerned base.

The app offers 3 demos detailed below.

## Basic example

*All The Things You Are* version Gerald Clayton. 
The first 2 A are in 7 (4+3), the bridge is 6 (3+3) and the last A is 5 (3+2) for 12 bars.

Les 2 premiers A sont en 7 (4+3), le pont en 6 (3+3) et le dernier A en 5 (3+2) sur 12 mesures. quarter = quarter.

We could use bars with metric 7, 6 and 5. Instead, let's use composed bars:

* 3 bases: 4/4, 3/4 et 2/4
	* base1: 240 4
	* base2: 240 3
	* base3: 240 2
* 3 patterns: bar's metric 7/4, 6/4 et 5/4
	* pattern1: 4/4 + 3/4
		* base1 x 1
		* base2 x 1
	* pattern2: 3/4 x 2
		* base2 x 2
	* pattern3: 3/4 + 2/4
		* base2 x 1
		* base3 x 1
* 1 structure:
	* structure1: AABA'
		* pattern1 x 8
		* pattern2 x 4
		* pattern3 x 6

## Equivalence example (preset "All Things")
There is no explicit mean to specify an equivalence in the structures menu. However, we can represent an equivalence as a judicious tempo change: with a basic math operation between the wished equivalence and the bpms.

Let's take the previous example but with a different rhythmic perspective. Instead of 4ths, we think halves: 4/4 becomes 2/2, 3/4 becomes 2 pointed 4ths and 2/4 becomes 1/2.

We simply need to halve the bpm and the bar metric.
However, in order to write 2 pointed 4ths, we will use "shorter" halves, like 75% (3/4) of their duration. So we need to increase the bpm by the inverse: 4/3 of 120 -> 160.
*(If we prefer the equivalence approach, let's just say that the 2 pointed 4ths bar is in fact a 2/2 bar preceded by an equivalence pointed 4th = half)*

In short, only the bases need changes:

* 3 bases: 2/2, 3/4 and 1/2
	* base1: 120 2 (2 halves)
	* base2: 160 2 (2 pointed 4ths. 160 = 120*4/3)
	* base3: 120 1 (1 half)

**Advice:** In order to ease equivalence, use a bpm that is divisible by 2 (half-time) and 3 (3-tuplet or pointed 4th) like 90, 120, 180. It eases the maths.

## Claves Examples

It is possible to abuse the Structures menu and make it play rhythms patterns.

### Clave "Ewe" (preset "Ewe")

For claves, we'll only use "tics. So bar <=1.

Let's think of the clave as a 12/8 pattern: 4th, 4th, 8th, 4th, 4th, 4th, 8th:

* 2 bases: 4th and 8th
	* base1: 120 1 (4th)
	* base2: 120 0.5 (8th)
* 1 pattern:
	* pattern1:
		* base1 x 2
		* base2 x 1
		* base1 x 3
		* base2 x 1
* 1 structure:
	* structure1:
		* pattern1 x 1

### Clave 2-3 (preset "2-3")

In some cases, we need silences. We'll use a base and set its "toc" sound to "muted".

* 4 bases: 4th, pointed 8th, 8th et half-rest (mute 8th)
	* base1: 120 1
	* base2: 120 0.75 or 160 1
	* base3: 120 0.5 or 240 1
	* base4: 240 0 (bar 0 only plays "tocs", here it's a 8th)
* 1 pattern:
	* pattern1:
		* base4 x 1
		* base3 x 1
		* base1 x 1
		* base2 x 2
		* base3 x 1
* 1 structure:
	* structure1:
		* pattern1 x 1
